'''
https://github.com/apache/arrow/blob/main/python/pyarrow/tests/test_cffi.py
'''
# -*- coding: utf-8 -*-
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

import ctypes
import pyarrow as pa
from pyarrow.cffi import ffi

    c_schema = ffi.new('struct ArrowSchema*')
    ptr_schema = int(ffi.cast('uintptr_t', c_schema))
    c_array = ffi.new('struct ArrowArray*')
    ptr_array = int(ffi.cast('uintptr_t', c_array))

    # pyarrow.Array._import_from_c(ptr_array, pa.list_(pa.int32()))

    # import gc
    # gc.collect()  # Make sure no Arrow data dangles in a ref cycle
    # pyarrow.Array._export_from_c(arr, ptr_array, ptr_schema)

    arr_new = pyarrow.Array._import_from_c(ptr_array, ptr_schema)


